package org.sap.utility;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Properties;

import org.sap.customerService.CustomerDetail;
import org.sap.customerService.CustomerProduct;
import org.sap.customerService.MessageHandler;

public class Advertisment
{

    String SMSContent;
    HashMap<String, CustomerProduct> customerProduct;
    HashMap<String, CustomerDetail> customerDetail;
    static Properties config;
    MessageHandler handler;
    String appKey;
    String appSecret;

    public Advertisment(UploadDetails details) throws IOException
    {
        System.out.println("Loading...");
        config = loadProperties("config.properties");
        String baseUrl = config.getProperty("baseUrl");
        appKey = config.getProperty("appKey"); //Replace with an App Key generated on the App Key area of the portal (Integrate - App Keys)
        appSecret = config.getProperty("appSecret"); //Replace with an App Secret generated on the App Key area of the portal (Integrate - App Keys)
        handler = new MessageHandler(baseUrl);
        customerProduct = new HashMap<String, CustomerProduct>();
        customerProduct = details.getCustomerProductMap();
        customerDetail = new HashMap<String, CustomerDetail>();
        customerDetail = details.getCustomerDetailMap();
        creditCardAdvertisment();
    }
    
    private Properties loadProperties(String filePath) throws IOException {
        Properties prop = new Properties();
        InputStream input = null;
        ClassLoader loader = Thread.currentThread().getContextClassLoader();

        try {
            input = loader.getResourceAsStream(filePath);
            // load a properties file
            prop.load(input);
        } catch (IOException ex) {
            ex.printStackTrace();
            throw ex;
        } finally {
            if (input != null) {
                try {
                    input.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return prop;
    }

    // One of the scenario is if a person do not have a credit card as his product
    public void creditCardAdvertisment() throws IOException
    {
        Iterator<String> productIterator = customerProduct.keySet().iterator();
        while(productIterator.hasNext())
        {
            String id = productIterator.next();
            CustomerProduct product = customerProduct.get(id);
            CustomerDetail details = customerDetail.get(id);
            ArrayList<String> productList = product.getProduct();
            if(productList.contains("CREDIT CARD") && (! (productList.contains("PREMIUM CARD"))))
            {
                SMSContent = "Hi " + details.getName() + ", We are offering a new Premoium Credit card for you. Upgrade your card to Premium Card with lots of Benefits";
            }
            handler.sendSMS(SMSContent, details.getMobileNumber() + "", handler.getAccessToken(this.appKey, this.appSecret));
        }
    }
}