package org.sap.utility;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

import org.sap.customerService.BankSalesPerson;
import org.sap.customerService.CustomerDetail;
import org.sap.customerService.CustomerProduct;

public class UploadDetails {

	HashMap<String, CustomerDetail> customerDetailMap;
	HashMap<String, CustomerProduct> customerProductMap;
	HashMap<String, BankSalesPerson> bankPersonDetails;
	
	public UploadDetails() throws IOException {
		customerDetailMap = new HashMap<String, CustomerDetail>();
		customerProductMap = new HashMap<String, CustomerProduct>();
		bankPersonDetails = new HashMap<String, BankSalesPerson>();
		loadCustomerDeatils();
		loadBankDetails();
	}
	
	/**
	 * This method will load all details of customer from csv file
	 * @throws IOException
	 */
	public void loadCustomerDeatils() throws IOException{
		FileReader fileRead = new FileReader(new File(getClass().getClassLoader().getResource("CustomerList.csv").getFile()));
		BufferedReader reader =new BufferedReader(fileRead);
		String record = null;
		while((record = reader.readLine()) != null )
		{
			CustomerDetail detail = new CustomerDetail();
			CustomerProduct product = new CustomerProduct();
			String[] customerDetailRecord = record.split("\\|");
			detail.setId(customerDetailRecord[0]);
			detail.setName(customerDetailRecord[1]);
			detail.setMobileNumber(Long.parseLong(customerDetailRecord[2]));
			customerDetailMap.put(detail.getId(), detail);
			product.setId(customerDetailRecord[0]);
			ArrayList<String> productList = new ArrayList<String>();
			for(int i = 3; i < customerDetailRecord.length;i++)
			{
				productList.add(customerDetailRecord[i]);
			}
			product.setProduct(productList);
			customerProductMap.put(detail.getId(), product);
		}
	}

	/**
	 * This method loads all the details of bank from a csv file
	 * @throws IOException
	 */
	public void loadBankDetails() throws IOException{
		FileReader fileRead = new FileReader(new File(getClass().getClassLoader().getResource("BankSalesPersonList.csv").getFile()));
		BufferedReader reader =new BufferedReader(fileRead);
		String record = null;
		while((record = reader.readLine()) != null ){
			BankSalesPerson salesPerson = new BankSalesPerson();
			String[] salesPersonDetail = record.split("\\|");
			salesPerson.setId(salesPersonDetail[0]);
			salesPerson.setName(salesPersonDetail[1]);
			salesPerson.setDepartment(salesPersonDetail[2]);
			salesPerson.setMobileNumber(Long.parseLong(salesPersonDetail[3]));
			bankPersonDetails.put(salesPerson.getId(), salesPerson);
		}
	}
	
	public HashMap<String, CustomerDetail> getCustomerDetailMap() {
		return customerDetailMap;
	}

	public void setCustomerDetailMap(HashMap<String, CustomerDetail> customerDetailMap) {
		this.customerDetailMap = customerDetailMap;
	}

	public HashMap<String, CustomerProduct> getCustomerProductMap() {
		return customerProductMap;
	}

	public void setCustomerProductMap(HashMap<String, CustomerProduct> customerProductMap) {
		this.customerProductMap = customerProductMap;
	}

	public HashMap<String, BankSalesPerson> getBankPersonDetails() {
		return bankPersonDetails;
	}

	public void setBankPersonDetails(HashMap<String, BankSalesPerson> bankPersonDetails) {
		this.bankPersonDetails = bankPersonDetails;
	}
	
	
}